void d180218116_get_bin_counts(int * starts_ump, int * ends_ump, 
                               int * cnts_input_bins,
                               int * cnts_ump_within_window,
                               int * ret1,
                               int * ret2){
  
  int i,j;
  
  int size_genome = ends_ump[cnts_input_bins[0]-1]+1;
  
  unsigned char *genome = malloc(size_genome);
  for(i = 0; i < size_genome; i++){
    genome[i] = 0;
  }
  
  int cnt_pos = 0;
  for(i = 0; i < cnts_input_bins[0]; i++){
    for(j = starts_ump[i]; j <= ends_ump[i]; j++){
      cnt_pos++;
      genome[j] = cnt_pos % cnts_ump_within_window[0];
      if(genome[j] == 0){
        genome[j] = cnts_ump_within_window[0];
      }
    }
  }
  
  int cnts_output_bins_parts = 0;
  int cnts_output_bins_uq = 0;

  for(i = 0; i < size_genome; i++){
    
    if(genome[i] == cnts_ump_within_window[0] || i == (size_genome - 1)){
      cnts_output_bins_uq++;
    }

    if(i == (size_genome - 1) || genome[i] > genome[i+1]){
      cnts_output_bins_parts++;
    }
  }
  
  ret1[0] = cnts_output_bins_parts;
  ret2[0] = cnts_output_bins_uq;
  
  free(genome);
}




/*

void d180218116_get_bin_counts(int * starts_ump, int * ends_ump, 
                               int * cnts_input_bins,
                               int * cnts_ump_within_window,
                               int * ret1,
                               int * ret2){
  
  int i,j;
  
  int size_genome = ends_ump[cnts_input_bins[0]-1]+1;
  
  unsigned char *genome = malloc(size_genome);
  
  
  for(i = 0; i < cnts_input_bins[0]; i++){
    for(j = starts_ump[i]; j <= ends_ump[i]; j++){
      genome[j] = 1;
    }
  }
  
  int cnts_output_bins_parts = 0;
  int cnts_output_bins_uq = 0;
  int cnts_ump_cur = 0;
  
  for(i = 0; i < size_genome; i++){
    if(genome[i] == 1){
      
      cnts_ump_cur++;
      
      //Check if the number of uniquely mappable positions in the current bin reaches the bin condition.
      if(cnts_ump_cur == cnts_ump_within_window[0]){
        cnts_output_bins_parts++;
        cnts_output_bins_uq++;
        cnts_ump_cur = 0;
      }
      
    }else{
      //Check if the index right before the current index i is the end of the previous uniquely mappable position region.
      if(i > 0 && genome[i-1] == 1 && cnts_ump_cur != 0){
        cnts_output_bins_parts++;
      }
    }
  }
  
  if(cnts_ump_cur > 0){
    cnts_output_bins_parts++;
    cnts_output_bins_uq++;
  }
  
  ret1[0] = cnts_output_bins_parts;
  ret2[0] = cnts_output_bins_uq;
  
  free(genome);
}
*/