void d180218121_get_bin_ranges(int * starts_ump, int * ends_ump, 
                               int * cnts_bin_umps,
                               int * cnts_ump_within_window,
                               int * cnts_bin_parts,
                               int * out_ids,
                               int * out_starts,
                               int * out_ends){
  
  int i,j;
  
  int size_genome = ends_ump[cnts_bin_umps[0]-1]+1;
  
  unsigned char *genome = malloc(size_genome);
  for(i = 0; i < size_genome; i++){
    genome[i] = 0;
  }
  
  int cnt_pos = 0;
  for(i = 0; i < cnts_bin_umps[0]; i++){
    for(j = starts_ump[i]; j <=ends_ump[i]; j++){
      cnt_pos++;
      genome[j] = cnt_pos % cnts_ump_within_window[0];
      if(genome[j] == 0){
        genome[j] = cnts_ump_within_window[0];
      }
    }
  }
  
  int id_output_bins_parts = 0;
  int id_output_bins_uq = 0;
  int start_cur;
  int end_cur;
  
  for(i = 0; i < size_genome; i++){

    if(genome[i] == 1 || (i > 0 && genome[i-1] == 0 && genome[i] > 0)){
      start_cur = i;
    }

    if(i == (size_genome - 1) || genome[i] == cnts_ump_within_window[0] || genome[i] > genome[i+1]){
      end_cur = i;

      out_ids[id_output_bins_parts] = id_output_bins_uq;
      out_starts[id_output_bins_parts] = start_cur;
      out_ends[id_output_bins_parts] = end_cur;
    }

    if(genome[i] == cnts_ump_within_window[0] || i == (size_genome - 1)){
      id_output_bins_uq++;
    }
    
    if(i == (size_genome - 1) || genome[i] > genome[i+1]){
      id_output_bins_parts++;
    }

  }

  free(genome);
}

/*
void d180218121_get_bin_ranges(int * starts_ump, int * ends_ump, 
                               int * cnts_bin_umps,
                               int * cnts_ump_within_window,
                               int * cnts_bin_parts,
                               int * out_ids,
                               int * out_starts,
                               int * out_ends){
  
  int i,j;
  
  int size_genome = ends_ump[cnts_bin_umps[0]-1]+1;
  
  unsigned char *genome = malloc(size_genome);
  
  for(i = 0; i < cnts_bin_umps[0]; i++){
    for(j = starts_ump[i]; j <=ends_ump[i]; j++){
      genome[j] = 1;
    }
  }
  
  int id_output_bins_parts = 0;
  int id_output_bins_uq = 0;
  int cnts_ump_cur = 0;
  int start_cur;
  
  for(i = 0; i < size_genome; i++){
    if(genome[i] == 1){
      
      //Set start of the bin : case 0 : i is the start position of the genome
      if(i == 0){
        start_cur = i;
        
      }else{
        
        //Set start of the bin : case 1 : i is the start position of the current uniquely mappable position region.
        if(genome[i-1] != 1){
          start_cur = i;
          //Set start of the bin : case 2 : new bin occurs within the current uniquely mappable position region.
        }else if(genome[i-1] == 1 && cnts_ump_cur == 0){
          start_cur = i;
        }
        
      }
      
      cnts_ump_cur++;
      
      //Check if the number of uniquely mappable positions in the bin reaches the condition.
      if(cnts_ump_cur == cnts_ump_within_window[0]){
        
        out_ids[id_output_bins_parts] = id_output_bins_uq;
        out_starts[id_output_bins_parts] = start_cur;
        out_ends[id_output_bins_parts] = i;
        
        id_output_bins_parts++;
        id_output_bins_uq++;
        cnts_ump_cur = 0;
      }
      
    }else{
      //Check if the i is the right before the end of previous uniquely mappable position region.
      if(i > 0 && genome[i-1] == 1 && cnts_ump_cur != 0){
        
        out_ids[id_output_bins_parts] = id_output_bins_uq;
        out_starts[id_output_bins_parts] = start_cur;
        out_ends[id_output_bins_parts] = i-1;
        
        id_output_bins_parts++;
      }
    }
  }
  
  if(cnts_ump_cur > 0){
    out_ids[id_output_bins_parts] = id_output_bins_uq;
    out_starts[id_output_bins_parts] = start_cur;
    out_ends[id_output_bins_parts] = ends_ump[cnts_bin_umps[0]-1];
  }
  
  free(genome);
}
*/