# rm(list=ls())
# options(warn = 2)
next_coeff = function(arg.scaling, arg.level){
  
  out.scaling = rep(0, length(arg.scaling))
  out.wavelet = rep(0, length(arg.scaling))
  
  num.packets = 2^(arg.level)
  
  length.packet = length(arg.scaling)/num.packets
  
  length.packet.next = length.packet/2
  
  index.packet = 1
  
  ee = lapply(1:num.packets, function(index.packet){
    
    #print("For nonshifted version of signal")
    indices.cur.nonshift = length.packet*(index.packet-1) + 1:length.packet
    indices.cur.left.nonshift = indices.cur.nonshift[1:length.packet.next*2-1]
    indices.cur.right.nonshift = indices.cur.nonshift[(1:length.packet.next)*2]
    
    
    index.next.start.nonshift = length.packet * (index.packet - 1) + 1
    indices.next.nonshift = index.next.start.nonshift:(index.next.start.nonshift+length.packet.next-1)
    out.scaling[indices.next.nonshift] <<- (arg.scaling[indices.cur.left.nonshift] + arg.scaling[indices.cur.right.nonshift])/sqrt(2)
    out.wavelet[indices.next.nonshift] <<- (arg.scaling[indices.cur.right.nonshift] - arg.scaling[indices.cur.left.nonshift])/sqrt(2)
    
    
    #print("For shifted version of signal")
    indices.cur.shift = c(indices.cur.nonshift[length(indices.cur.nonshift)], indices.cur.nonshift[1:(length(indices.cur.nonshift)-1)])
    indices.cur.left.shift = indices.cur.shift[1:length.packet.next*2-1]
    indices.cur.right.shift = indices.cur.shift[(1:length.packet.next)*2]
    
    
    index.next.start.shift = length.packet * (index.packet - 1) + 1 + length.packet.next
    indices.next.shift = index.next.start.shift:(index.next.start.shift+length.packet.next-1)
    
    out.scaling[indices.next.shift] <<- (arg.scaling[indices.cur.left.shift] + arg.scaling[indices.cur.right.shift])/sqrt(2)
    out.wavelet[indices.next.shift] <<- (arg.scaling[indices.cur.right.shift] - arg.scaling[indices.cur.left.shift])/sqrt(2)
    
  })
  
  return(list(scaling = out.scaling, 
              wavelet = out.wavelet))
  
}



prev_coeff = function(arg.scaling, 
                      arg.wavelet,
                      arg.level){
  
  out.scaling = rep(0, length(arg.scaling))
  
  num.packets.cur = 2^(arg.level)
  length.packet.cur = length(arg.scaling)/num.packets.cur
  
  num.packets.prev = num.packets.cur/2
  length.packet.prev = length(arg.scaling)/num.packets.prev
  
  # index.packet.prev = 2
  
  ee = lapply(1:num.packets.prev, function(index.packet.prev){
    # print(index.packet.prev)
    
    #print("For nonshifted version of signal")
    indices.cur.nonshift = length.packet.prev*(index.packet.prev-1) + 1:length.packet.cur
    #print("For shifted version of signal")
    indices.cur.shift = length.packet.prev*(index.packet.prev-1) + length.packet.cur + 1:length.packet.cur
    
    indices.prev.odd = (1:length.packet.cur) * 2 - 1
    indices.prev.even = (1:length.packet.cur) * 2
    
    #print("Set Upsampled, nonshifted, scaling")
    scaling.up.nonshift = rep(0, length.packet.prev)
    scaling.up.nonshift[indices.prev.odd] = arg.scaling[indices.cur.nonshift]/sqrt(2)
    scaling.up.nonshift[indices.prev.even] = arg.scaling[indices.cur.nonshift]/sqrt(2)
    
    #print("Set Upsampled, nonshifted, wavelet")
    wavelet.up.nonshift = rep(0, length.packet.prev)
    wavelet.up.nonshift[indices.prev.odd] = -arg.wavelet[indices.cur.nonshift]/sqrt(2)
    wavelet.up.nonshift[indices.prev.even] = arg.wavelet[indices.cur.nonshift]/sqrt(2)
    
    #print("Set Upsampled, shifted, scaling")
    scaling.up.shift = rep(0, length.packet.prev)
    scaling.up.shift[indices.prev.odd] = arg.scaling[indices.cur.shift]/sqrt(2)
    scaling.up.shift[indices.prev.even] = arg.scaling[indices.cur.shift]/sqrt(2)
    
    #print("Set Upsampled, shifted, wavelet")
    wavelet.up.shift = rep(0, length.packet.prev)
    wavelet.up.shift[indices.prev.odd] = -arg.wavelet[indices.cur.shift]/sqrt(2)
    wavelet.up.shift[indices.prev.even] = arg.wavelet[indices.cur.shift]/sqrt(2)
    
    #print("Sum")
    sum.scaling = (scaling.up.nonshift + c(scaling.up.shift[2:length(scaling.up.shift)], scaling.up.shift[1]))/2
    sum.wavelet = (wavelet.up.nonshift + c(wavelet.up.shift[2:length(wavelet.up.shift)], wavelet.up.shift[1]))/2
    indices.prev.all = length.packet.prev*(index.packet.prev-1) + (1:length.packet.prev)
    out.scaling[indices.prev.all] <<- sum.scaling + sum.wavelet
    
  })
  
  return(out.scaling)
}


d180201301_make_symmetric_form = function(arg.raw){
  
  pow_of_intermediate_signal = log2(4*length(arg.raw))
  pow_of_symmetric_signal = ceiling(pow_of_intermediate_signal)
  
  ret.1 = rep(0, 2^pow_of_symmetric_signal)
  
  
  # print("Put original signal")
  ret.1[length(arg.raw) + 1:length(arg.raw)] = arg.raw
  
  # print("Put reversed signal")
  ret.1[1:length(arg.raw)] = arg.raw[length(arg.raw):1]
  
  # print("Put above parts to the adjacent parts")
  ret.1[(length(arg.raw)*2) + (1:(length(arg.raw)*2))] = ret.1[(1:(length(arg.raw)*2))]
  
  # print("Fill the rest parts")
  if(pow_of_intermediate_signal != pow_of_symmetric_signal){
    ret.1[(length(arg.raw)*4+1):(2^pow_of_symmetric_signal)] = ret.1[1:((2^pow_of_symmetric_signal)-(length(arg.raw)*4))]
  }
  
  return(ret.1)
}


d180201306_estimate_noise = function(arg.coef){
  return(mad(arg.coef)*sqrt(2*log(length(arg.coef))))
}


d180101331_denoising = function(arg.input, arg.level, arg.C){
  
  input.1 = d180201301_make_symmetric_form(arg.input)
  
  # cur.level = 1
  
  coef.cur = input.1
  
  list.wavelet.raw = list()
  
  print("Decomposition")
  for(cur.level in 1:arg.level){
    print(cur.level)
    tmp.1 = next_coeff(arg.scaling = coef.cur,
                       arg.level = cur.level-1)
    list.wavelet.raw[[cur.level]] = tmp.1$wavelet
    coef.cur = tmp.1$scaling
  }
  
  scaling.raw = coef.cur
  
  
  list.noise.raw = list()
  print("Noise Estimate")
  for(cur.level in 1:arg.level){
    print(cur.level)
    tmp.1 = list.wavelet.raw[[cur.level]]
    tmp.2 = tmp.1[1:(2^(log2(length(tmp.1))-cur.level))]
    thres.1 = d180201306_estimate_noise(tmp.2)
    list.noise.raw[[cur.level]] = thres.1
  }
  
  
  # cur.level = 3
  print("Thresholding & Reconstruction")
  scaling.raw.2 = scaling.raw
  for(cur.level in arg.level:1){
    print(cur.level)
    tmp.wavelet.1 = list.wavelet.raw[[cur.level]]
    tmp.wavelet.1[abs(tmp.wavelet.1) <= arg.C*list.noise.raw[[cur.level]]] = 0
    
    scaling.raw.2 = prev_coeff(arg.scaling = scaling.raw.2,
                               arg.wavelet = tmp.wavelet.1,
                               arg.level = cur.level)
  }
  
  ret.1 = scaling.raw.2[length(arg.input) + (1:length(arg.input))]
  
  return(ret.1)
}

# dev.off()



get_approx_for_next_level = function(arg.gc,
                                     arg.level){
  
  num.packets = 2^(arg.level)
  
  length.packet = length(arg.gc)/num.packets
  
  do.call(c, lapply(1:num.packets, function(index.packet){
    length.packet.next = length.packet/2
    
    indices.GC.nonshift = length.packet*(index.packet-1) + 1:length.packet
    indices.left.nonshift = indices.GC.nonshift[1:length.packet.next*2-1]
    indices.right.nonshift = indices.GC.nonshift[(1:length.packet.next)*2]
    gc.nonshift = arg.gc[indices.left.nonshift] + arg.gc[indices.right.nonshift]
    
    
    indices.GC.shift  = c(indices.GC.nonshift[length(indices.GC.nonshift)], indices.GC.nonshift[1:(length(indices.GC.nonshift)-1)])
    indices.left.shift = indices.GC.shift[1:length.packet.next*2-1]
    indices.right.shift = indices.GC.shift[(1:length.packet.next)*2]
    gc.shift = arg.gc[indices.left.shift] + arg.gc[indices.right.shift]
    
    c(gc.nonshift, gc.shift)
  }))
  
}


get_detail_for_next_level = function(arg.gc,
                                     arg.level){
  
  num.packets = 2^(arg.level)
  
  length.packet = length(arg.gc)/num.packets
  
  rbindlist(lapply(1:num.packets, function(index.packet){
    length.packet.next = length.packet/2
    
    indices.GC.nonshift = length.packet*(index.packet-1) + 1:length.packet
    indices.left.nonshift = indices.GC.nonshift[1:length.packet.next*2-1]
    indices.right.nonshift = indices.GC.nonshift[(1:length.packet.next)*2]
    
    
    indices.GC.shift  = c(indices.GC.nonshift[length(indices.GC.nonshift)], indices.GC.nonshift[1:(length(indices.GC.nonshift)-1)])
    indices.left.shift = indices.GC.shift[1:length.packet.next*2-1]
    indices.right.shift = indices.GC.shift[(1:length.packet.next)*2]
    gc.shift = arg.gc[indices.left.shift] + arg.gc[indices.right.shift]
    
    rbind(data.table(left.gc = arg.gc[indices.left.nonshift], right.gc = arg.gc[indices.right.nonshift]),
          data.table(left.gc = arg.gc[indices.left.shift], right.gc = arg.gc[indices.right.shift]))
  }))
  
}

d180109151_draw_DOC = function(arg.starts = NULL,
                               arg.ends = NULL,
                               arg.values = NULL,
                               path.in = NULL,
                               path.out,
                               arg.starts.abline = c(),
                               arg.ends.abline = c(),
                               arg.range.x = c(0, 250000000),
                               arg.range.y = c(0, 5),
                               arg.lwd = 10,
                               arg.title = "Copy number value plot",
                               arg.length_seg_width = NULL,
                               arg.xlab = "Genome",
                               arg.ylab = "Copy number"){
  
  path.out.tmp = sprintf("%s.tmp", path.out)
  
  print("Draw plot")
  png(path.out.tmp, width = 36, height = 8, units = "in", res = 300)
  plot(1, 
       type="n", 
       xlab=arg.xlab, 
       ylab=arg.ylab, 
       xlim=arg.range.x, 
       ylim=arg.range.y, 
       main = arg.title)
  
  print("Draw neutral line")
  abline(h = 1, col = "green")
  
  if(!is.null(path.in)){
    print("Load files")  
    if(length(grep("gz$", arg.path.in)) > 0){
      bin.1 = fread(sprintf("zcat %s", arg.path.in))
    }else{
      bin.1 = fread(arg.path.in)
    }
  }else{
    print("From object")
    bin.1 = data.table(start = arg.starts,
                       end = arg.ends,
                       value = arg.values)
  }
  
  
  print("Draw segments")
  d180108116_draw_segments_of_a_chromosome(arg.starts = bin.1$start,
                                           arg.ends = bin.1$end,
                                           arg.values = bin.1$value, 
                                           arg.col = "black",
                                           arg.lwd = arg.lwd,
                                           arg.length_seg_width = arg.length_seg_width,
                                           arg.draw_segments_out_of_range = T)
  
  print("Draw abline for highlighting some genome regions")
  for(i in 1:length(arg.starts.abline)){
    abline(v = arg.starts.abline[i], 
           col = "red")
    abline(v = arg.ends.abline[i], 
           col = "red")
  }
  
  dev.off()
  file.rename(path.out.tmp, path.out)
}


# print("Function for drawing segments from the file")
d180108116_draw_segments_of_a_chromosome = function(arg.starts,
                                                    arg.ends, 
                                                    arg.values, 
                                                    arg.col = "black",
                                                    arg.lwd = 1,
                                                    arg.length_seg_width = NULL,
                                                    arg.draw_segments_out_of_range = T){
  
  # print("Load files")  
  # if(length(grep("gz$", arg.path.in)) > 0){
  #   bin.1 = fread(sprintf("zcat %s", arg.path.in))
  # }else{
  #   bin.1 = fread(arg.path.in)
  # }
  # 
  # bin.2 = data.table(bin.1)
  bin.2 = data.table(start = arg.starts,
                     end = arg.ends,
                     value = arg.values)
  
  # setnames(bin.2, c("start", "value"))
  
  print("Calculate end positions of the segments")
  if(is.null(arg.length_seg_width)){
    print("Calculate end positions from the given start positions")
    len.diff.1 = diff(bin.2$start)
    len.diff.2 = c(len.diff.1, median(len.diff.1))
    bin.2$end = bin.2$start + len.diff.2 - 1
  }else{
    print("Calculate end positions from the given fixed width")
    bin.2$end = bin.2$start + arg.length_seg_width - 1
  }
  
  
  print("Draw segments")  
  segments(x0 = bin.2$start,
           x1 = bin.2$end, 
           y0 =bin.2$value ,
           y1 = bin.2$value,
           col = arg.col,
           lwd = arg.lwd)
  
  
  
  if(arg.draw_segments_out_of_range){
    print("Draw segments out of plot range.")      
    out.1 = bin.2[bin.2$value > par("usr")[4],]
    if(nrow(out.1) > 0){
      segments(x0 = out.1$start, 
               x1 = out.1$end, 
               y0 = par("usr")[4] , 
               y1 = par("usr")[4], 
               lwd = arg.lwd*5, 
               col = "blue")
    }
  }
  
}

# print("Extract read position and mapping quality pairs.")

d161220151 = function(seqName, path.bam){
  
  require(Rsamtools)
  
  
  ref.names = names(scanBamHeader(path.bam)[[path.bam]]$targets)
  
  #Convert seqName
  if(is.integer(seqName)){
    seqName = sprintf("%d", seqName)
  }
  
  
  if(any(ref.names %in% seqName)){
    print("Ref seq name kept")
  }else if(any(ref.names %in% sprintf("chr%s", seqName))){
    seqName = sprintf("chr%s", seqName)
    print("Prefix 'chr' is added to the Ref seq name")
  }else{
    stop("No available ref seq name in the bam file. Exit")
  }
  
  
  param <- ScanBamParam(what = c("pos", "mapq"), 
                        which = GRanges(seqName, 
                                        IRanges(1, 530000000)), scanBamFlag(isUnmappedQuery = FALSE))
  
  
  #Scan the bam file
  sample.1 <- scanBam(path.bam, param = param)
  
  #Extract read mapping position and mapping qualities
  mapq = sample.1[[1]]["mapq"][[1]]
  pos = sample.1[[1]]["pos"][[1]]
  
  #Make data.table and sort by mapping positions
  mappings.1 = data.table(pos, mapq)
  setkey(mappings.1$pos)
  mappings = mappings.1[order(pos),]
  
  return(mappings)
}

#Make 1bp bins(Call aggregate() in normalization.c in BICseq program)
#For independent call of the function, the original code have been modified
#But code d150520008_aggregate.c do the same with original code.

d161220158 = function(path.c_lib, arg.mappings){
  dyn.load(path.c_lib)
  
  n_reads = nrow(arg.mappings)
  pos_range = tail(arg.mappings$pos,1) - arg.mappings$pos[1] + 1
  my.size = ifelse(n_reads < pos_range, n_reads, pos_range)
  
  my.result = .C("aggregate", as.integer(arg.mappings$pos), as.integer(nrow(arg.mappings)),
                 as.integer(rep(0, my.size)), as.integer(rep(0, my.size)), as.integer(0))
  
  my.table = data.table(pos = my.result[[3]][1:my.result[[5]]], 
                        cnt = my.result[[4]][1:my.result[[5]]])
  
  mapped_positions = my.result[[5]]
  
  # rm(my.result)
  # rm(arg.mappings)
  
  return(list(bins = my.table, num.positions = mapped_positions))
}


d180218106_make_DOC_bin = function(path.in.bam, 
                                   paths.in.unique_pos,
                                   cnts_ump_within_window,
                                   arg.chrs,
                                   path.lib.1bp_bins,
                                   path.lib.get_bin_counts,
                                   path.lib.get_bin_ranges,
                                   path.lib.count_doc_within_ranges){
  
  print("Load lib")
  library(data.table)
  dyn.load(path.lib.1bp_bins)
  dyn.load(path.lib.get_bin_counts)
  dyn.load(path.lib.get_bin_ranges)
  dyn.load(path.lib.count_doc_within_ranges)
  
  list.doc = list()
  list.marker = list()
  
  # arg.chr = 1
  
  indices.1 = 1:length(arg.chrs)
  
  eee = lapply(indices.1, function(arg.index){
    
    arg.chr = arg.chrs[arg.index]
    print(arg.chr)
    path.in.upos = paths.in.unique_pos[arg.index]
    
    
    print("Read pair of mapped position and mapping quality")
    mappings.tumor.1 = d161220151(arg.chr,
                                  path.in.bam)
    
    # print("Filter out mapped reads with low mapping qualities")
    # mappings.tumor.2 = d161220156(arg.mappings = mappings.tumor.1,
    #                               thres.quality = 0)
    mappings.tumor.2 = mappings.tumor.1
    
    print("1bp bin")
    bin.1bp.tumor.1 = d161220158(path.lib.1bp_bins,
                                 mappings.tumor.2)[[1]]
    
    
    # print("Uniquely mappable positions")
    upos.1 = fread(path.in.upos)
    setnames(upos.1, c("start.uq", "end.uq"))
    
    out <- .C("d180218116_get_bin_counts",
              as.integer(upos.1$start.uq),
              as.integer(upos.1$end.uq),
              as.integer(nrow(upos.1)),
              as.integer(cnts_ump_within_window),
              as.integer(1),
              as.integer(1))
    num_overlaps = out[[5]]
    
    print(sprintf("num_overlaps:%d",num_overlaps))
    
    bin.2 <- .C("d180218121_get_bin_ranges",
                as.integer(upos.1$start.uq),
                as.integer(upos.1$end.uq),
                as.integer(nrow(upos.1)),
                as.integer(cnts_ump_within_window),
                as.integer(num_overlaps),
                as.integer(rep(0, num_overlaps)),
                as.integer(rep(0, num_overlaps)),
                as.integer(rep(0, num_overlaps)))
    
    bin.3 = data.table(id = bin.2[[6]],
                       start = bin.2[[7]],
                       end = bin.2[[8]])
    bin.3$length = bin.3$end - bin.3$start + 1
    
    
    bin.4 = .C("d180219121_count_doc_within_ranges",
               as.integer(bin.1bp.tumor.1$pos),
               as.integer(bin.1bp.tumor.1$cnt),
               as.integer(nrow(bin.1bp.tumor.1)),
               
               as.integer(bin.3$start),
               as.integer(bin.3$end),
               as.integer(nrow(bin.3)),
               
               as.integer(rep(0, nrow(bin.3))))
    bin.3$cnt = bin.4[[7]]
    
    
    bin.5 = setDT(bin.3)[,.(start = min(start),
                            end = max(end),
                            length = sum(length),
                            cnt = sum(cnt)),
                         by = 'id']
    
    if(tail(bin.5,1)$length != cnts_ump_within_window){
      print("Include the last record if the number of uniquely mappable positions in the record is less than the required numbers for the bin.")
      bin.5$id[nrow(bin.5)] = bin.5$id[nrow(bin.5)] - 1
      bin.5 = setDT(bin.5)[,.(start = min(start),
                              end = max(end),
                              length = sum(length),
                              cnt = sum(cnt)),
                           by = 'id']
    }
    
    print("Store result")
    list.doc[[arg.chr]] <<- bin.5$cnt
    list.marker[[arg.chr]] <<- data.table(start = bin.5$start, end = bin.5$end)
    
    return(NULL)
  })
  
  return(list(doc = list.doc, marker = list.marker))
}



d180207106_self11 = function(arg.list.doc, 
                             arg.list.marker, 
                             arg.path.umpositions, 
                             arg.path.ref,
                             arg.thres.stop = 0.5,
                             arg.max_decomposition_level = 10,
                             path.lib.calc_num_overlap,
                             path.lib.calc_range_overlap,
                             path.lib.get_gc){
  print("Load lib")
  library(data.table)
  library(limma)
  library(fields)
  dyn.load(path.lib.calc_num_overlap)
  dyn.load(path.lib.calc_range_overlap)
  dyn.load(path.lib.get_gc)
  
  writeLines("\nCalculate GC counts of uniquely mappable positions in markers")
  
  arg.list.gc = lapply(1:length(arg.list.marker), function(arg.index){
    writeLines(sprintf("%s", arg.index))
    seg.1 = arg.list.marker[[arg.index]]
    
    writeLines("Uniquely mappable positions")
    upos.1 = fread(arg.path.umpositions[arg.index])
    setnames(upos.1, c("start.uq", "end.uq"))
    
    out <- .C("d160810390_calc_num_of_overlaps_between_two_sets_of_ranges",
              as.integer(nrow(seg.1)),
              as.integer(seg.1$start),
              as.integer(seg.1$end),
              as.integer(nrow(upos.1)),
              as.integer(upos.1$start.uq),
              as.integer(upos.1$end.uq),
              as.integer(1))
    num_overlaps = out[[7]]
    
    
    ret.1 <- .C("d160811216_calc_overlaps_between_two_sets_of_ranges",
                as.integer(nrow(seg.1)),
                as.integer(seg.1$start),
                as.integer(seg.1$end),
                as.integer(nrow(upos.1)),
                as.integer(upos.1$start.uq),
                as.integer(upos.1$end.uq),
                as.integer(rep(0, num_overlaps)),
                as.integer(rep(0, num_overlaps)),
                as.integer(rep(0, num_overlaps)))
    
    ret.2 = cbind(cbind(seg.1[ret.1[[7]],],
                        upos.1[ret.1[[8]],]),
                  num_overlaps = ret.1[[9]])
    
    ret.2$start.over = ifelse(ret.2$start < ret.2$start.uq, ret.2$start.uq, ret.2$start)
    ret.2$end.over = ifelse(ret.2$end < ret.2$end.uq, ret.2$end, ret.2$end.uq)
    
    
    ret.3 = .C("d170626121_get_gc_from_starts_and_ends",
               as.character(arg.path.ref[arg.index]),
               as.integer(nrow(ret.2)),
               as.integer(ret.2$start.over),
               as.integer(ret.2$end.over),
               as.integer(rep(0,nrow(ret.2))),
               as.integer(rep(0,nrow(ret.2))),
               as.integer(rep(0,nrow(ret.2))))
    
    ret.4 = ret.2
    ret.4$cnt.gc = ret.3[[5]]
    ret.4$cnt.at = ret.3[[6]]
    ret.4$cnt.N = ret.3[[7]]
    
    ret.5 = ret.4[,c("start", "end", "num_overlaps", "cnt.gc", "cnt.at", "cnt.N"), with = F]
    setkey(ret.5, start)
    
    seg.2 = merge(seg.1[,c("start","end"), with = F],
                  setDT(ret.5)[,.(cnt.uqpositions = sum(num_overlaps),
                                  cnt.gc = sum(cnt.gc),
                                  cnt.at = sum(cnt.at),
                                  cnt.N = sum(cnt.N)), 
                               by = 'start'],
                  by = "start")
    
    seg.3 = seg.2[,c("start", "end", "cnt.gc", "cnt.at", "cnt.N", "cnt.uqpositions"), with = F]
    setnames(seg.3, c("start", "end", "GC", "AT", "N", "uq.mappable.positions"))
    
    seg.3[,c("GC", "AT"), with = F]
  })
  
  names(arg.list.gc) = names(arg.list.doc)
  
  
  
  writeLines("\nGet GC curve for raw DOC")
  
  median.raw.doc = median(unlist(arg.list.doc))
  
  ratio.raw.1 = rbindlist(lapply(names(arg.list.doc), function(arg.chr){
    writeLines(arg.chr)
    data.table(gc = arg.list.gc[[arg.chr]]$GC/(arg.list.gc[[arg.chr]]$GC + arg.list.gc[[arg.chr]]$AT),
               ratio = arg.list.doc[[arg.chr]]/median.raw.doc)
  }))
  ratio.raw.2 = loessFit(ratio.raw.1$ratio,
                         ratio.raw.1$gc)
  ratio.raw.3 = unique(data.table(gc = ratio.raw.1$gc, 
                                  ratio = ratio.raw.2$fitted))
  ratio.raw.3 = ratio.raw.3[order(ratio.raw.3$gc),]
  
  
  
  writeLines("\nMake list objects for storing intermediate results")  
  list.scaling.raw = list()
  list.wavelet.raw = list()
  
  list.scaling.gc = list()
  list.wavelet.gc = list()
  
  list.scaling.fitted = list()
  list.wavelet.fitted = list()
  
  list.GC_curves = list()
  
  writeLines("\nObject for storing artificial control DOC")
  list.artificial = list()
  
  # arg.chr = "01"
  arg.chr = names(arg.list.marker)[1]
  
  
  writeLines("\nMake symmetric form")
  eee = lapply(names(arg.list.doc), function(arg.chr){
    writeLines(arg.chr)
    list.scaling.raw[[arg.chr]] <<- d180201301_make_symmetric_form(arg.raw = arg.list.doc[[arg.chr]])
    list.scaling.gc[[arg.chr]] <<- data.table(GC = d180201301_make_symmetric_form(arg.raw = arg.list.gc[[arg.chr]]$GC),
                                              AT = d180201301_make_symmetric_form(arg.raw = arg.list.gc[[arg.chr]]$AT))
  })
  
  
  
  # next.level = 1
  # next.level = 2
  # arg.chr = "01"
  writeLines("\nDecomposition of observed signal and construction of artificial signal")
  for(next.level in 1:arg.max_decomposition_level){
    
    writeLines(sprintf("\n\nDecomposition level : %d\n\n", next.level))
    list.wavelet.fitted[[next.level]] = list()
    
    writeLines("\nDecompose signal and calculate GC proportion of the coefficients")
    eee = lapply(names(arg.list.doc), function(arg.chr){
      writeLines(arg.chr)
      
      doc.1 = list.scaling.raw[[arg.chr]]
      gc.1 = list.scaling.gc[[arg.chr]]$GC
      at.1 = list.scaling.gc[[arg.chr]]$AT
      
      list.coef = next_coeff(arg.scaling = doc.1,
                             arg.level = next.level - 1)
      
      list.scaling.raw[[arg.chr]] <<- list.coef[["scaling"]]
      list.wavelet.raw[[arg.chr]] <<- list.coef[["wavelet"]]
      
      list.scaling.gc[[arg.chr]] <<- data.table(GC = get_approx_for_next_level(arg.gc = gc.1,
                                                                               arg.level = next.level - 1),
                                                AT = get_approx_for_next_level(arg.gc = at.1,
                                                                               arg.level = next.level - 1))
      
      list.wavelet.gc[[arg.chr]] <<- data.table(get_detail_for_next_level(arg.gc = gc.1,
                                                                          arg.level = next.level - 1),
                                                get_detail_for_next_level(arg.gc = at.1,
                                                                          arg.level = next.level - 1))
      
      setnames(list.wavelet.gc[[arg.chr]], c("left.gc", "right.gc", "left.at", "right.at"))
      
    })
    
    
    # prev.1 = fread("zcat /DAS_Storage3/hjang/cnv_detection/sub.170910.wavelet_coef_and_gc_GBM/171017121.ti_coef_and_gc/id_0125-01A_chr_01_j.loc_023_type.coef_approx_level_001.gc_coef.gz")
    # # prev.1 = fread("zcat /DAS_Storage3/hjang/cnv_detection/sub.170910.wavelet_coef_and_gc_GBM/171017121.ti_coef_and_gc/id_0125-01A_chr_01_j.loc_023_type.coef_approx_level_002.gc_coef.gz")
    # nrow(prev.1)
    # prev.2 = unique(prev.1[,c("coef", "GC", "AT"), with = F])
    # nrow(prev.2)
    # prev.3 = prev.2[order(prev.2$GC,prev.2$AT),]
    # range(prev.3$coef)
    # quantile(prev.3$coef, 0.99)
    # plot(density(prev.3$coef[prev.3$coef < 460]), xlim = c(0, 500))
    # 
    # cur.1 = list.scaling.gc[[arg.chr]]
    # cur.2 = unique(data.table(coef = list.scaling.raw[[arg.chr]], list.scaling.gc[[arg.chr]]))
    # nrow(cur.2)
    # cur.3 = cur.2[order(cur.2$GC,cur.2$AT),]
    # range(cur.3$coef)
    # plot(density(cur.3$coef), xlim = c(0, 1000))
    # plot(density(cur.3$coef[cur.3$coef < 460]), xlim = c(0, 500))
    
    writeLines("\nScaling coefficient fitting")
    
    scaling.raw.1 = rbindlist(lapply(names(arg.list.doc), function(arg.chr){ 
      writeLines(arg.chr)
      data.table(GC = list.scaling.gc[[arg.chr]]$GC,
                 AT = list.scaling.gc[[arg.chr]]$AT,
                 gc = list.scaling.gc[[arg.chr]]$GC/(list.scaling.gc[[arg.chr]]$GC + list.scaling.gc[[arg.chr]]$AT),
                 scaling = list.scaling.raw[[arg.chr]])
    }))
    
    scaling.fit.1 <- loessFit(scaling.raw.1$scaling,
                              scaling.raw.1$gc)
    
    scaling.fit.2 <- unique(data.table(GC = scaling.raw.1$GC, 
                                       AT = scaling.raw.1$AT, 
                                       gc = scaling.raw.1$gc, 
                                       scaling = scaling.fit.1$fitted))
    
    # cur.fitted = scaling.fit.2[order(scaling.fit.2$GC, scaling.fit.2$AT),]
    # plot(cur.fitted$gc, cur.fitted$scaling, col = "blue", ylim = c(-5, 210))
    # 
    # prev.fitted = fread("/DAS_Storage3/hjang/cnv_detection/sub.170910.wavelet_coef_and_gc_GBM/171018101.GC_kernel_smoothing/id_0125-01A_type.coef_approx_level_001.gc_coef.fitted")
    # points(prev.fitted$gc, prev.fitted$coef, col = "red")
    
    
    writeLines("\nAssign fitted coefficient, Scaling coefficients")
    eee = lapply(names(arg.list.doc), function(arg.chr){
      writeLines(arg.chr)
      
      # tmp.1 = data.frame(order = 1:nrow(list.scaling.gc[[arg.chr]]),
      #                    GC = list.scaling.gc[[arg.chr]]$GC,
      #                    AT = list.scaling.gc[[arg.chr]]$AT,
      #                    # gc = list.scaling.gc[[arg.chr]]$GC/(list.scaling.gc[[arg.chr]]$GC+list.scaling.gc[[arg.chr]]$AT),
      #                    scaling.raw = list.scaling.raw[[arg.chr]])
      # scaling.fitted.1 = data.table(merge(tmp.1,
      #                                     data.frame(scaling.fit.2[,c("GC", "AT", "scaling"), with = F]),
      #                                     by = c("GC", "AT")))
      
      
      tmp.1 = data.table(order = 1:nrow(list.scaling.gc[[arg.chr]]),
                         GC = list.scaling.gc[[arg.chr]]$GC,
                         AT = list.scaling.gc[[arg.chr]]$AT)
      scaling.fitted.1 = data.table(merge(tmp.1,
                                          scaling.fit.2[,c("GC", "AT", "scaling"), with = F],
                                          by = c("GC", "AT")))[, c("order", "scaling"), with =F]
      
      scaling.fitted.2 = scaling.fitted.1[order(scaling.fitted.1$order), ]$scaling
      
      list.scaling.fitted[[arg.chr]] <<- scaling.fitted.2
      return(NULL)
    })
    
    
    
    writeLines("\nWavelet coefficient fitting")
    
    
    wavelet.raw.1 = unique(rbindlist(lapply(names(arg.list.doc), function(arg.chr){
      writeLines(arg.chr)
      data.table(gc.left = list.wavelet.gc[[arg.chr]]$left.gc/(list.wavelet.gc[[arg.chr]]$left.gc + list.wavelet.gc[[arg.chr]]$left.at),
                 gc.right = list.wavelet.gc[[arg.chr]]$right.gc/(list.wavelet.gc[[arg.chr]]$right.gc + list.wavelet.gc[[arg.chr]]$right.at),
                 wavelet = list.wavelet.raw[[arg.chr]])
    })))
    
    
    waveling.fit.1 <-smooth.2d(wavelet.raw.1$wavelet,
                               x = wavelet.raw.1[,c("gc.left", "gc.right"), with = F],
                               theta = 0.25,
                               nrow = 100,
                               ncol = 100,
                               Nwidth = 32,
                               Mwidth = 32)
    
    waveling.fit.2 = rbindlist(lapply(1:length(waveling.fit.1$x), function(index.row){
      data.table(knot.gc.left = waveling.fit.1$x[index.row],
                 knot.gc.right = waveling.fit.1$y,
                 id.gc.left = index.row,
                 id.gc.right = 1:length(waveling.fit.1$y),
                 wavelet = waveling.fit.1$z[index.row,])
    }))
    
    
    # arg.chr = names(arg.list.doc)[1]
    
    writeLines("\nAssign fitted coefficient, Wavelet coefficients")
    eee = lapply(names(arg.list.doc), function(arg.chr){
      writeLines(arg.chr)
      
      tmp.1 = data.table(order = 1:nrow(list.wavelet.gc[[arg.chr]]),
                         gc.left = list.wavelet.gc[[arg.chr]]$left.gc/(list.wavelet.gc[[arg.chr]]$left.gc + list.wavelet.gc[[arg.chr]]$left.at),
                         gc.right = list.wavelet.gc[[arg.chr]]$right.gc/(list.wavelet.gc[[arg.chr]]$right.gc + list.wavelet.gc[[arg.chr]]$right.at))
      
      
      tmp.1$id.gc.left = findInterval(tmp.1$gc.left,
                                      waveling.fit.1$x)
      
      tmp.1$id.gc.right = findInterval(tmp.1$gc.right,
                                       waveling.fit.1$y)
      
      # tmp.1$id.gc.left = unlist(lapply(tmp.1$gc.left, function(arg.gc.cur){
      #   which.min(abs(arg.gc.cur - waveling.fit.1$x))
      # }))
      #
      # tmp.1$id.gc.right = unlist(lapply(tmp.1$gc.right, function(arg.gc.neighbour){
      #   which.min(abs(arg.gc.neighbour - waveling.fit.1$y))
      # }))
      
      
      tmp.2 = merge(tmp.1[, c("order","id.gc.left","id.gc.right"), with = F],
                    waveling.fit.2[, c("id.gc.left","id.gc.right","wavelet"), with = F],
                    by = c("id.gc.left", "id.gc.right"))
      tmp.2 = tmp.2[order(tmp.2$order),]
      
      list.wavelet.fitted[[next.level]][[arg.chr]] <<- tmp.2$wavelet
      return(NULL)
      
      #
      # dt = data.table(x, val = x) # you'll see why val is needed in a sec
      # setattr(dt, "sorted", "x")  # let data.table know that w is sorted
      # setkey(dt, x) # sorts the data
      # dt[J(your.number), roll = "nearest"]
      
    })
    
    
    writeLines("\nConstruct artificial control signal")
    eee = lapply(names(arg.list.doc), function(arg.chr){
      writeLines(arg.chr)
      
      cur.scaling = list.scaling.fitted[[arg.chr]]
      for(cur.level in next.level:1){
        writeLines(sprintf("level : %d", cur.level))
        cur.scaling = prev_coeff(arg.scaling = cur.scaling,
                                 # arg.wavelet = list.wavelet.fitted[[cur.level]][[arg.chr]],
                                 arg.wavelet = rep(0, length(cur.scaling)),
                                 arg.level = cur.level)
      }
      
      list.artificial[[arg.chr]] <<- cur.scaling[length(arg.list.doc[[arg.chr]]) + 1:length(arg.list.doc[[arg.chr]])]
      
    })
    
    
    writeLines("\nGet corrected copy number ratio using current artificial control DOC")
    ratio.cur.1 = rbindlist(lapply(names(arg.list.doc), function(arg.chr){
      writeLines(arg.chr)
      data.table(gc = arg.list.gc[[arg.chr]]$GC/(arg.list.gc[[arg.chr]]$GC + arg.list.gc[[arg.chr]]$AT),
                 ratio = arg.list.doc[[arg.chr]]/list.artificial[[arg.chr]])
    }))
    ratio.cur.2 = loessFit(ratio.cur.1$ratio,
                           ratio.cur.1$gc)
    ratio.cur.3 = unique(data.table(gc = ratio.cur.1$gc, 
                                    ratio = ratio.cur.2$fitted))
    ratio.cur.3 = ratio.cur.3[order(ratio.cur.3$gc),]
    
    writeLines("\nSave GC curves of intermediate results")
    list.GC_curves[[next.level]] = ratio.cur.3
    
    
    if(next.level == 1){
      writeLines("\nCalculate initial direction")
      
      # plot(1, type = "n", xlim = c(0, 130), ylim = c(-2,2))
      # points(ratio.raw.3$ratio)
      # points(ratio.cur.3$ratio, col = "red")
      # points(ratio.cur.3$ratio - ratio.raw.3$ratio, col = "blue")
      # points(ratio.cur.3$ratio, col = "yellow")
      # points(ratio.cur.3$ratio - ratio.raw.3$ratio, col = "yellow")
      
      direction.initial = sign(ratio.cur.3$ratio - ratio.raw.3$ratio)
      
    }else{
      
      writeLines("\nCheck stop condition")
      
      ratio.consistent_change_direction = length(which(direction.initial == sign(ratio.cur.3$ratio - ratio.raw.3$ratio)))/nrow(ratio.raw.3)
      writeLines(sprintf("Ratio consistent change direction : %f",ratio.consistent_change_direction))
      
      if(ratio.consistent_change_direction < arg.thres.stop){
        writeLines("\nStop")
        break;
      }
    }
    
  }
  
  return(list(curve.initial = ratio.raw.3,
              curves.corrected = list.GC_curves,
              artificial = list.artificial))
  
}


d180220101_from_bam_to_plot = function(arg.chrs,
                                       path.in.bam,
                                       paths.in.unique_pos,
                                       path.ref,
                                       dir.out,
                                       arg.thres.stop,
                                       arg.max_decomposition_level,
                                       cnts_ump_within_window = 100,
                                       path.lib.1bp_bins = "d150520008_aggregate.so",
                                       path.lib.get_bin_counts = "d180218116_get_bin_counts.so",
                                       path.lib.get_bin_ranges = "d180218121_get_bin_ranges.so",
                                       path.lib.count_doc_within_ranges = "d180219121_count_doc_within_ranges.so",
                                       path.lib.calc_num_overlap = "d160810390_calc_num_of_overlaps_between_two_sets_of_ranges.so",
                                       path.lib.calc_range_overlap = "d160811216_calc_overlaps_between_two_sets_of_ranges.so",
                                       path.lib.get_gc = "d170626121_get_gc_from_starts_and_ends.so"){
  
  print("Create output dir")
  dir.create(dir.out, recursive = T, showWarnings = F)
  path.log = sprintf("%s/log.txt", dir.out)
  sink(path.log)
  
  
  print("Make raw DOC from the bam file")
  list.res = d180218106_make_DOC_bin(path.in.bam = path.in.bam,
                                     paths.in.unique_pos = paths.in.unique_pos,
                                     cnts_ump_within_window = cnts_ump_within_window,
                                     arg.chrs = arg.chrs,
                                     path.lib.1bp_bins = path.lib.1bp_bins,
                                     path.lib.get_bin_counts = path.lib.get_bin_counts,
                                     path.lib.get_bin_ranges = path.lib.get_bin_ranges,
                                     path.lib.count_doc_within_ranges = path.lib.count_doc_within_ranges)
  
  path.out.raw = sprintf("%s/raw.RData", dir.out)
  save(list.res, file = path.out.raw)
  
  print("Make artificial control DOC")
  artificial.1 = d180207106_self11(arg.list.doc = list.res$doc,
                                   arg.list.marker = list.res$marker,
                                   arg.path.umpositions = paths.in.unique_pos,
                                   arg.path.ref = path.ref,
                                   arg.thres.stop = arg.thres.stop,
                                   arg.max_decomposition_level = arg.max_decomposition_level,
                                   path.lib.calc_num_overlap = path.lib.calc_num_overlap,
                                   path.lib.calc_range_overlap = path.lib.calc_range_overlap,
                                   path.lib.get_gc = path.lib.get_gc)
  
  path.out.corrected = sprintf("%s/corrected.RData", dir.out)
  save(artificial.1, 
       file = path.out.corrected)
  
  print("Draw plot raw")
  median.raw = median(unlist(list.res$doc))
  
  ttt = lapply(names(list.res$doc), function(arg.chr){
    print(arg.chr)
    
    denoised.1 = d180101331_denoising(arg.input = list.res$doc[[arg.chr]]/median.raw,
                                      arg.level = 15,
                                      arg.C = 2)
    
    d180109151_draw_DOC(arg.starts = list.res$marker[[arg.chr]]$start,
                        arg.ends = list.res$marker[[arg.chr]]$end,
                        arg.values = denoised.1,
                        arg.lwd = 1,
                        path.out = sprintf("%s/raw_%s.png", dir.out, arg.chr))
    
  })
  
  
  
  print("Draw plot corrected")
  ttt = lapply(names(list.res$doc), function(arg.chr){
    print(arg.chr)
    
    denoised.1 = d180101331_denoising(arg.input = list.res$doc[[arg.chr]]/artificial.1$artificial[[arg.chr]],
                                      arg.level = 15,
                                      arg.C = 2)
    
    d180109151_draw_DOC(arg.starts = list.res$marker[[arg.chr]]$start,
                        arg.ends = list.res$marker[[arg.chr]]$end,
                        arg.values = denoised.1,
                        arg.lwd = 1,
                        path.out = sprintf("%s/corrected_%s.png", dir.out, arg.chr))
    
  })
  
  sink()
}

myexample = function(){
  
  # R CMD SHLIB d150520008_aggregate.c -o d150520008_aggregate.so
  # R CMD SHLIB d160810390_calc_num_of_overlaps_between_two_sets_of_ranges.c -o d160810390_calc_num_of_overlaps_between_two_sets_of_ranges.so
  # R CMD SHLIB d160811216_calc_overlaps_between_two_sets_of_ranges.c -o d160811216_calc_overlaps_between_two_sets_of_ranges.so
  # R CMD SHLIB d170626121_get_gc_from_starts_and_ends.c -o d170626121_get_gc_from_starts_and_ends.so
  # R CMD SHLIB d180218116_get_bin_counts.c -o d180218116_get_bin_counts.so
  # R CMD SHLIB d180218121_get_bin_ranges.c -o d180218121_get_bin_ranges.so
  # R CMD SHLIB d180219121_count_doc_within_ranges.c -o d180219121_count_doc_within_ranges.so
  
  # arg.chrs = sprintf("%d", 1:22)
  arg.chrs = c("12", "21")

  d180220101_from_bam_to_plot(arg.chrs = arg.chrs,
                              path.in.bam = "/DAS_Storage4/TCGA/LUNG/WGS_high_coverage/2a573319-62d3-4659-ba01-e021c8f45e45/G25787.TCGA-78-7156-01A-11D-2036-08.1.bam",
                              paths.in.unique_pos = sprintf("/home/hjang/Dropbox/160403799.hjang_dropbox/BICseq2/hg19CRG.50bp/hg19.50mer.CRC.chr%s.txt", arg.chrs),
                              path.ref = sprintf("/DAS_Storage4/hjang/cnv_detection_sync/sub.140102.reference_sequence/160601666.ucsc_hg19_chromFa/chr%s.fa", arg.chrs),
                              dir.out = "/DAS_Storage4/hjang/cnv_detection_all/180220111.test_results",
                              arg.thres.stop = 0.5,
                              arg.max_decomposition_level = 10,
                              cnts_ump_within_window = 100,
                              path.lib.1bp_bins = "d150520008_aggregate.so",
                              path.lib.get_bin_counts = "d180218116_get_bin_counts.so",
                              path.lib.get_bin_ranges = "d180218121_get_bin_ranges.so",
                              path.lib.count_doc_within_ranges = "d180219121_count_doc_within_ranges.so",
                              path.lib.calc_num_overlap = "d160810390_calc_num_of_overlaps_between_two_sets_of_ranges.so",
                              path.lib.calc_range_overlap = "d160811216_calc_overlaps_between_two_sets_of_ranges.so",
                              path.lib.get_gc = "d170626121_get_gc_from_starts_and_ends.so")
    
}



